#include <pthread.h>
#include <iostream>
using namespace std;

pthread_mutex_t mux1 = PTHREAD_MUTEX_INITIALIZER,
                mux2 = PTHREAD_MUTEX_INITIALIZER;

void* tfunc ( void* parm ) {
   int rep = (int)parm;
   for( int i = 0; i < rep; i++ ) {
      pthread_mutex_lock( &mux2 );
      cout << "child: строка №" << i + 1 << endl;
      pthread_mutex_unlock( &mux1 );
   }
   return NULL;
};

int main( int argc, char *argv[] ) {
   pthread_mutex_lock( &mux2 );
   pthread_t tid;
   const int rep = 5;
   pthread_create( &tid, NULL, tfunc, (void*)rep );
   for( int i = 0; i < rep; i++ ) {
      pthread_mutex_lock( &mux1 );
      cout << "parent: строка №" << i + 1 << endl;
      pthread_mutex_unlock( &mux2 );
   }
   pthread_join( tid, NULL );
};

