#include <iostream>
#include <thread>
#include <mutex>     
using namespace std;

mutex mux1, mux2;

void tfunc( int rep ) {
   for( int i = 0; i < rep; i++ ) {
      mux2.lock();
      cout << "child: строка №" << i + 1 << endl;
      mux1.unlock();
   }
};

int main( int argc, char *argv[] ) {
   mux2.lock();
   const int rep = 5;
   thread thr( tfunc, rep ); 
   for( int i = 0; i < rep; i++ ) {
      mux1.lock();
      cout << "parent: строка №" << i + 1 << endl;
      mux2.unlock();
   }
   thr.join();
};
